Subject: X11 vs RDP vs Spice for Remote applications on Alpine?

From: LonnieTC <[email-masked]>
Date: Fri, 23 Feb 2024 07:36:42 -0500

Morning All,

I am researching various methods to run applications on remote systems 
via Alpine and am looking at X11 vs RDP vs Spice. The objective is to be 
as versatile and performant as possible with low footprint as these will 
be in ultra-small VM's and run on a RAM-based Alpine-Xen system.

While RDP has typically been used in Windows based machines, I have 
found on that platform, that the protocol is really efficient and offers 
a notion of "channels" in which streams can be set up to handle video, 
audio, USB, network drives, local drives, printers as well as allows for 
"seamless" mode which uses local windowing like X11.  The catch is that 
it really is not heavily viable for Linux based machines like Alpine 
although there is the XRDP project which might be a good starting point 
which is namely for logins.

The X11 via Xorg is a tried and true approach for remote applications, 
it seems to have a heavy footprint (around 800 MB) and uses a much older 
protocol. I have seen specialized distros like "Siltaz" that has simple 
25MB to 40MB Xserver ISO's and even one that boots Xorg+Firefox from an 
ISO with only about 40MB used, which is interesting as well.

The Spice protocol approach, from what I have researched, was "supposed" 
to be the cross platform evolution of X11 which was to offer many 
performant features like RDP, but it does not seem to have caught on 
well and its future is uncertain from what I can see which probably 
translates to a minimal following and development effort, I guess.

Of course, there is the flavors of VNC but that protocol does not offer 
any viable solution for the ideas of channels like RDP and Spice and is 
actually a bit more sluggish in performance compared to those as well 
given the way that it pushes the image data.

Anyway, I thought that I would ask the Alpine group here more about your 
opinion and experience with these to try and get an idea on how things 
should proceed on this project effort.

Have a great day,
Lonnie